package com.hzya.frame.seeyon.invoice.service.impl;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.mdm.mdmModuleSource.dao.impl.MdmModuleSourceDaoImpl;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.seeyon.invoice.dao.IInvoiceDao;
import com.hzya.frame.seeyon.invoice.dao.IInvoiceDetailsDao;
import com.hzya.frame.seeyon.invoice.entity.InvoiceEntity;
import com.hzya.frame.seeyon.invoice.service.IInvoiceService;
import com.hzya.frame.seeyon.util.YzfSignUtil;
import com.hzya.frame.seeyon.zxbank.entity.ZxBankEntity;
import com.hzya.frame.sysnew.comparison.service.impl.ComparisonServiceImpl;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.uuid.UUIDUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.*;

@Service(value = "InvoiceServiceImpl")
public class InvoiceServiceImpl extends BaseService<InvoiceEntity, String> implements IInvoiceService {
    @Autowired
    private MdmModuleSourceDaoImpl mdmModuleSourceDaoImpl;

    @Autowired
    private IInvoiceDao invoiceDao;
    @Autowired
    private IInvoiceDetailsDao invoiceDetailsDao;

    @Autowired
    private IIntegrationTaskLivingDetailsService taskLivingDetailsService;
    @Autowired
    private ComparisonServiceImpl comparisonServiceimpl;

    @Value("${zt.url}")
    private String url;

    @Override
    public JsonResultEntity queryArchives(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        //根据插件分类查询主数据来源表
        List<MdmModuleSourceEntity> list = mdmModuleSourceDaoImpl.MdmModuleSourceentityGroupByType();
        if (CollectionUtils.isEmpty(list)) {
            logger.info("没有类型为插件得数据,无法获取数据");
            return BaseResult.getFailureMessageEntity("数据来源表无插件类型");
        }
        for (MdmModuleSourceEntity mdmModuleSourceEntity : list) {
            String tableName = "";
            List<Object> object=new ArrayList<>();
            List<JSONObject> listAll  = new ArrayList<>();
            try {
                String appTyp = mdmModuleSourceEntity.getAppType();//系统类型  1、致远OA 2、用友U8C 3、用友BIP
                String dbCode = mdmModuleSourceEntity.getDbCode();//数据源编码
                String mdmCode = mdmModuleSourceEntity.getMdmCode();//主数据编码
                switch (appTyp){
                    case "1":
                        switch (mdmCode){
                            case "10049"://杭泰开票申请单
                                tableName = "mdm_invoice_application";
                                listAll = bindingInvoice(jsonObject, mdmModuleSourceEntity, dbCode);
                                break;
                            default:
                                break;
                        }
                        break;
                    default:
                        break;
                }
                //将查询出来的数据进行组装，调用通用方法新增或者更新
                if (null != listAll && listAll.size() > 0) {
                    object = ParametricDocument(listAll, mdmCode, tableName);
                } else {
                    logger.info("三维单据视图数据没有需要同步中台的数据");
                }
            }catch (Exception e){
                logger.info("杭泰付款单同步失败:{}",e.getMessage());
                saveTaskLivingDetails(JSONObject.parseObject(listAll.get(0).getString("mdm_invoice_application")).getString("data_id"),JSONObject.parseObject(listAll.get(0).getString("mdm_invoice_application")).getString("business_no"),listAll.get(0).toString(),JSON.parseObject(JSON.toJSONString(object)).getString("msg")==null?JSON.parseObject(JSON.toJSONString(object)).getString("list"):JSON.parseObject(JSON.toJSONString(object)).getString("msg"),false,"MakeInvoicePluginInitializer");
                e.printStackTrace();
            }
        }
        return BaseResult.getSuccessMessageEntity("开票申请单同步成功");
    }

    @Override
    public JsonResultEntity queryInvoiceResult(JSONObject json) {
        try {
            InvoiceEntity invoiceEntity = json.toJavaObject(InvoiceEntity.class);
            invoiceEntity.setDataSourceCode("HT-OA");
            logger.info("=======开始查询杭泰税务的开票申请单返回结果=========");
            List<InvoiceEntity> invoiceEntities = invoiceDao.queryInvoiceResult(invoiceEntity);
            if(CollectionUtils.isEmpty(invoiceEntities)){
                logger.info("=====杭泰税务中没有需要查询申请单详情得数据========");
                return BaseResult.getSuccessMessageEntity("查询成功");
            }
            for (InvoiceEntity entity : invoiceEntities) {
                long timestamp = System.currentTimeMillis();
                Map<String, Object> parametersMap = new HashMap<>();
                parametersMap.put("accessKey","6X3B526P5HqE6ums");
                parametersMap.put("timestamp",timestamp);
                String sign = YzfSignUtil.signRequest(parametersMap,"34e5fc32ac894a2ba2ade8c3852c7a0a");
                 JSONObject jsonObject=new JSONObject();
                 jsonObject.put("serialNumber",entity.getBusiness_no());
                 jsonObject.put("accessKey","6X3B526P5HqE6ums");
                 jsonObject.put("sign",sign);
                 jsonObject.put("timestamp",timestamp);
                 logger.info("=======调用杭泰税务查询申请单详情的请求参数为:{}=======",jsonObject.toJSONString());
                //发送数据
                String result = HttpRequest.post(url).
                        header("appId", "800060").
                        header("apiCode", "8000600003").
                                header("publicKey", "ZJYAmRjjYEDgqw4UXWHZNicYclErG0hsrwKQcHukPlP0K1pCe7eDIk+3zDUT+v578prj").
                        header("secretKey", "D6AHU3PL8UsNfK6A8I6mL4X1ma2NXckX/vM7AOzI/jmzJf+R1aY06Q6SBz7Y7drHj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=").
                        body(jsonObject.toJSONString()).
                        execute().
                        body();
                logger.info("=====调用杭泰税务查询申请单详情的返回参数为:{}===========",result);

            }
        }catch (Exception e){
            logger.info("======查询杭泰税务申请单详情失败====",e.getMessage());
            e.printStackTrace();
        }
        return null;
    }

    private List<JSONObject> bindingInvoice(JSONObject jsonObject, MdmModuleSourceEntity mdmModuleSourceEntity, String dbCode) {
        List<JSONObject> list = new ArrayList<>();
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append("select * from v_hzya_invoice where push_status is null ");
        mdmModuleSourceEntity.setDataSourceCode(dbCode);
        List<HashMap<String, Object>> hashMaps = invoiceDao.queryInvoice(stringBuffer.toString(), mdmModuleSourceEntity);
        int i = 0;
        if (CollectionUtils.isNotEmpty(hashMaps)) {
            for (HashMap<String, Object> hashMap : hashMaps) {
                JSONObject main = new JSONObject();
                JSONObject invoice = new JSONObject();
                for (String key : hashMap.keySet()) {
                    invoice.put(key.toLowerCase(), hashMap.get(key));
                }
                //获取明细信息
                Long formmainId = (Long) hashMap.get("data_id");
                StringBuffer stringBufferDetails = new StringBuffer();
                stringBufferDetails.append("SELECT * FROM v_hzya_invoice_details WHERE f_id = '"+formmainId+"' " );
                List<HashMap<String, Object>> hashMapsDetails = invoiceDetailsDao.queryInvoiceDetails(stringBufferDetails.toString(),mdmModuleSourceEntity);
                JSONArray invoiceDetails = new JSONArray();
                if(CollectionUtils.isNotEmpty(hashMapsDetails)){
                    for (HashMap<String, Object> detailsMap : hashMapsDetails) {
                        JSONObject details = new JSONObject();
                        for (String key : detailsMap.keySet()) {
                            details.put(key.toLowerCase(), detailsMap.get(key));
                        }
                        invoiceDetails.add(details);
                    }
                }
                main.put("mdm_invoice_application_details", invoiceDetails);
                main.put("mdm_invoice_application", invoice);
                list.add(main);
            }
        }
        return list;
    }

    private List<Object> ParametricDocument(List<JSONObject>  hashMaps,String mdmCode,String tableName){
        JSONObject jsonObjectUser = new JSONObject();
        List<Object> result=new ArrayList<>();
        try {
            for (JSONObject hashMap : hashMaps) {
                JSONObject main = hashMap.getJSONObject(tableName);
                JSONObject jsonStr = new JSONObject();
                jsonObjectUser.put("data_id", main.get("data_id"));
                jsonObjectUser.put("mdmCode", mdmCode);
                jsonStr.put("jsonStr", jsonObjectUser);
                //先查询编码和名称查询是否存在
                Object attribute = comparisonServiceimpl.queryEntityPage(jsonStr);
                logger.info("得到的attribute值为：{}", jsonStr.toJSONString(attribute));
                JSONObject jsonObjectAttribute = (JSONObject) JSON.toJSON(attribute);
                JSONObject pageInfo = jsonObjectAttribute.getJSONObject("pageInfo");
                JSONArray jsonArrayList = pageInfo.getJSONArray("list");
                //如果jsonArrayList为null，说明没有值，在表中不存在
                if (jsonArrayList == null || jsonArrayList.size() == 0) {
                    hashMap.put("appName","数智中台");
                    hashMap.put("appCode","800004");
                    hashMap.put("mdmCode", mdmCode);
                    hashMap.put("optionName", "数智中台");
                    jsonStr.put("jsonStr", hashMap);
                    Object  object = comparisonServiceimpl.saveEntity(jsonStr);
                    logger.info("应付单新增结果为：{}", JSON.toJSONString(object));
                    result.add(object);
                } else {
                    hashMap.put("appName","数智中台");
                    hashMap.put("appCode","800004");
                    hashMap.put("mdmCode", mdmCode);
                    hashMap.put("optionName", "数智中台");
                    jsonStr.put("jsonStr", hashMap);
                    Object object = comparisonServiceimpl.updateEntity(jsonStr);
                    logger.info("应付单更新结果为：{}", JSON.toJSONString(result));
                    result.add(object);
                }
            }
            return result;
        }catch (Exception e){
            logger.info("将数据查询之后进行组装调用通用方法错误:{}",e.getMessage());
            //保存业务数据日志
            saveTaskLivingDetails(jsonObjectUser.getString("data_id"),hashMaps.get(0).getString("business_no"),hashMaps.get(0).toString(),result.toString(),false,"MakeInvoicePluginInitializer");
            e.printStackTrace();
        }
        return null;
    }

    private void saveTaskLivingDetails(String rootAppPk,String rootAppBill,String rootAppNewData,String newTransmitInfo,boolean flag,String plugin) {
        try {
            IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity = new IntegrationTaskLivingDetailsEntity();
            integrationTaskLivingDetailsEntity.setId(UUIDUtils.getUUID());
            integrationTaskLivingDetailsEntity.setSts("Y");
            integrationTaskLivingDetailsEntity.setCreate_user_id("1");
            integrationTaskLivingDetailsEntity.setModify_user_id("1");
            integrationTaskLivingDetailsEntity.setCreate_time(new Date());
            integrationTaskLivingDetailsEntity.setModify_time(new Date());
            integrationTaskLivingDetailsEntity.setOrg_id("0");
            integrationTaskLivingDetailsEntity.setCompanyId("0");
            integrationTaskLivingDetailsEntity.setRootAppPk(rootAppPk);
            integrationTaskLivingDetailsEntity.setRootAppBill(rootAppBill);
            integrationTaskLivingDetailsEntity.setPluginId(plugin);
            integrationTaskLivingDetailsEntity.setRootAppNewData(rootAppNewData);
            integrationTaskLivingDetailsEntity.setNewTransmitInfo(newTransmitInfo);
            if(flag){
                taskLivingDetailsService.saveLogToSuccess(integrationTaskLivingDetailsEntity);
            }else {
                taskLivingDetailsService.saveLogToFail(integrationTaskLivingDetailsEntity);
            }
        }catch (Exception e){
            logger.info("抽取杭泰付款单保存日志到集成任务日志明细中失败:{}",e.getMessage());
            e.printStackTrace();
        }
    }

}
